VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Screen Saver Main Form"
   ClientHeight    =   5016
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6768
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5016
   ScaleWidth      =   6768
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   WindowState     =   2  'Maximized
   Begin VB.Timer Timer2 
      Interval        =   10000
      Left            =   360
      Top             =   960
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   360
      Top             =   1440
   End
   Begin VB.Label lblValue 
      BackColor       =   &H00000000&
      BackStyle       =   0  'Transparent
      Caption         =   "Averaging data over 60 seconds..."
      ForeColor       =   &H00FFFFFF&
      Height          =   252
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   3372
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This holds out CPU utilization results
Private QueryObject As Object

' These are the hooks for finding our memory utilization
Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYDATA)
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Type MEMORYDATA
        Length As Long
        MemoryLoad As Long
        TotalPhys As Long
        AvailPhys As Long
        TotalPageFile As Long
        AvailPageFile As Long
        TotalVirtual As Long
        AvailVirtual As Long
End Type
Dim MemStats As MEMORYDATA

' Several variables to manage our results
Dim Newdata As Long
Dim Accumulator As Long
Dim Counter As Integer

' If this is set to 1 we don't monopolize the screen
Dim Debugging As Integer

' Our configuration settings
Dim DisplayValue As Integer
Dim SnakeMethod As Integer
Public SnakeColor As Long

Dim MouseMoves As Integer

Private Function GetMemoryStatus(MemStats As MEMORYDATA)
    GlobalMemoryStatus MemStats
End Function

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
   If Debugging = 0 Then
      'End when any key is pressed
      Unload Me
   End If
End Sub

Private Sub Form_Load()
    ' If we're in debugging mode we don't totally take control of the screen.
    Debugging = 0
    
    ' Get our settings from the registry
    DisplayValue = GetSetting("PerformanceSnakeSaver", "Setup", "DisplayValue")
    SnakeMethod = GetSetting("PerformanceSnakeSaver", "Setup", "SnakeMethod")
    SnakeColor = GetSetting("PerformanceSnakeSaver", "Setup", "SnakeColor")
    ' The user may or may not want us to display the current value
    If DisplayValue = 0 Then
       frmMain.lblValue.Visible = False
    Else
       frmMain.lblValue.Visible = True
    End If
        
    ' Make the window cover everything else on the screen
    Me.WindowState = 2 ' Maximize
    Move 0, 0, Screen.Width, Screen.Height ' for good measure
    If Debugging = 0 Then
       Newdata = SetWindowPos(hWnd, -1, 0, 0, 0, 0, FLAGS) ' cover everything
    End If

    'Make the cursor disappear
    If Debugging = 0 Then
       Do
       Loop Until ShowCursor(False) < -5
    End If
    
    ' We start off in a random direction from the middle of the screen.
    Randomize Timer
    Direction = Int(4 * Rnd + 1)
    Points(0, 0) = frmMain.ScaleWidth / 2
    Points(1, 0) = frmMain.ScaleHeight / 2
    Radius = 120 ' This is the diameter of each circle in the snakes body
    Speed = 105
    TailLength = 5 ' Start off at 5
    
    ' Setup everything for the CPU Monitor
    Set QueryObject = New cpuinfo
    QueryObject.Initialize

    Accumulator = 0
    Counter = 0
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
   If Debugging = 0 Then
      MouseMoves = MouseMoves + 1
      If MouseMoves > 5 Then
         Unload Me
      End If
   End If
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    ' End if any mouse buttons are pressed
    Unload Me
End Sub


Private Sub Form_Unload(Cancel As Integer)
    ' Restore the mouse cursor
    Do
    Loop Until ShowCursor(True) > 5
    
    ' Clean up
    QueryObject.Terminate
    Set QueryObject = Nothing
End Sub

Private Sub Timer1_Timer()
    Select Case Direction
    Case 1
      ' Up and Right
      UpdateScreen
      If Points(0, 0) >= frmMain.ScaleWidth Then
        Direction = 4
      ElseIf Points(1, 0) <= 0 Then
        Direction = 2
      End If
    Case 2
      ' Down and Right
      UpdateScreen
      If Points(0, 0) >= frmMain.ScaleWidth Then
        Direction = 3
      ElseIf Points(1, 0) >= frmMain.ScaleHeight Then
        Direction = 1
      End If
    Case 3
      ' Down and Left
      UpdateScreen
      If Points(0, 0) <= 0 Then
        Direction = 2
      ElseIf Points(1, 0) >= frmMain.ScaleHeight Then
        Direction = 4
      End If
    Case 4
      ' Up and Left
      UpdateScreen
      If Points(0, 0) <= 0 Then
        Direction = 1
      ElseIf Points(1, 0) <= 0 Then
        Direction = 3
      End If
    End Select
End Sub

Private Sub Timer2_Timer()
    ' We collect the data every 10 seconds and update the
    ' snake length once a minute based on the average of
    ' values recorded over the past 60 seconds.
    Counter = Counter + 1
    If SnakeMethod = 1 Then     ' CPU
       Newdata = QueryObject.Query
    ElseIf SnakeMethod = 2 Then ' Memory
       GetMemoryStatus MemStats
       Newdata = (((CStr(MemStats.TotalPageFile) - CStr(MemStats.AvailPageFile)) / CStr(MemStats.TotalPageFile)) * 100)
    ElseIf SnakeMethod = 3 Then ' Silly User
    Else
       MsgBox ("Unknown Monitor Method Type.")
       End
    End If
    Accumulator = Accumulator + CStr(Newdata)
    
    If Counter = 6 Then
       Newdata = Round(Accumulator / 6)
       TailLength = Newdata + 5
       lblValue.Caption = CStr(Newdata) + " %"
       Counter = 0
       Accumulator = 0
    End If
End Sub
